FA_DMGTYPE={ [0] = "Physical", [1] = "Poison", [2] = "Fire", [3] = "Acid", [4] = "Electric", 
		   [5] = "Cold", [6] = "Death", [7] = "Holy", [8] = "Force", 
		   [9] = "CastFail", -- not dmg type, just used for automised creation of widgets
		   [10] = "Stun",
		   [11] = "Dodge",  
		   [12] = "DmgMult",
		   [13] = "DefDmg"
		}
FA_MAGIC={ [0] = "Evocation", [1] = "Transmutation", [2] ="Conjuration", [3] = "Enchantment", 
		  [4] = "Necromancy", [5] = "Illusion", [6] = "Abjuration", [7] = "Divination"}


FA_COLOR = { 
	[0] = {0.7,0.7,0.7,1},
	[1] = {0,1,0,1},
	[2] = {1,0,0,1},
	[3] = {0,0.5,0,1},
	[4] = {0,0.45,1,1},
	[5] = {0.5,0.5,1,1},
	[6] = {0.66,0,0.9,1},
	[7] = {0.2,1,1,1},
	[8] = {1,1,0,1},
	[9] = {1,0,0,1},
	[10] = {0,0.74,0.87,1},
	[11] = {1,1,1,1}, 
	[12] = {1,1,1,1},
	[13] = {1,1,1,1},
}

FA_MCOLOR = { 
	[0] = {0.6,0.02,0.02,1},
	[1] = {0.97,0.67,0.03,1},
	[2] = {0.94,0.39,0.44,1},
	[3] = {1,0.96,0.03,1},
	[4] = {0.8,0,0.75,1},
	[5] = {0.76,0.37,0.91,1},
	[6] = {0,0.06,0.85,1},
	[7] = {0.61,0.61,0.61,1},
}


function SResistWindow(inst,stats,offset)
	if not inst or not stats then return end
	local name = stats
	stats = stats .. "stats"
	if inst[stats] and inst[stats].Kill then inst[stats]:Kill() end
	inst[stats] = inst:AddChild(Widget(stats))
	local i = inst[stats]
	local p = GetPlayer()
	i.owner = p
	i.monitor = nil
	i.hpstr = ""
	if name == "monster" then
		i.target = nil
	else
		i.target = p
	end

	local w = 75
	local h = 184
	local step = 20
	local fontsize = 20
	local c = nil
	local color = nil
	local yoffset = 100

	if not IsHID then
		h = 64
		yoffset = 20
	end

	local y = h - step

	if not offset or type(offset)~="number" then offset = 0 end

	i.root = i:AddChild(Widget("ROOT"))
	i.root:SetVAnchor(ANCHOR_TOP)
	i.root:SetHAnchor(ANCHOR_LEFT)
	i.root:SetPosition(w + 50 + offset, -(h + yoffset), 0)

	i.bgg = i.root:AddChild(Image("images/ui.xml", "black.tex"))
   	i.bgg:ScaleToSize(w*2,h*2)
	i.bgg:SetTint(0,0,0,0.6)

	i.title = i.root:AddChild(Text(textfont, fontsize + 1))
	i.title:SetPosition(0, y, 0)
	i.title:SetString("[ " .. name .. "'s stats ]")

	y = y - step - 5
	i.pname = i.root:AddChild(Text(textfont, 20))
	i.pname:SetColour(1, 1 ,1 ,1)
        i.pname:SetPosition(0, y, 0)
	i.pname:SetString("")
	i.pname:EnableWordWrap(true)

	y = y - 20
	i.hp = i.root:AddChild(Text(textfont, 20))
	i.hp:SetColour(0.02, 0.71 ,0.02 ,1)
        i.hp:SetPosition(0, y, 0)
	i.hp:SetString("")
	i.hp:EnableWordWrap(true)
	
	function i.hp:ShowHP()
		if i.target and i.target.components and i.target.components.health then
			local h = i.target.components.health
			local m = h:GetMaxHealth()
			if not m or type(m)~="number" or m < 0 then m = 0 end
			local c = h:GetPercent() + h:GetPenaltyPercent()
			if not c or type(c)~="number" or c < 0 then c = 0 else c = c*m end
			local news = tostring(math.floor(c+0.5)).." / "..tostring(math.floor(m+0.5))
			self:SetString(news)
		end
	end

	if name=="player" then
		i.pname:SetString(p.prefab)
	end
	
	y = y - 5

	local k1 = 0
	local k2 = 13

	if not IsHID then
		k1 = 12
	end

	for k = k1,k2,1 do
		v = string.lower(FA_DMGTYPE[k])
		y = y - step
		i[v] = i.root:AddChild(Text(textfont, fontsize))
		c = i[v]
		color = FA_COLOR[k]
		c:SetColour(color[1], color[2], color[3], 1)
        	c:SetPosition(0, y, 0)
		c.dmg = v
		c.resistance = 0
		c.protection = 0
		function c:SetData(resistance,protection)
			if resistance and type(resistance)=="number" then self.resistance = resistance end
			if protection and type(protection)=="number" then self.protection = protection end
			if (math.abs(self.resistance) > MATH_PREC) or (math.abs(self.protection) > MATH_PREC) then
				self:SetString(tostring(self.dmg).." "..percentstr(self.resistance).." / "..percentstr(self.protection))
			else
				self:SetString("")
			end
		end

		function c:SetResistance(val)
			self:SetData(val,nil)
		end
		function c:SetProtection(val)
			self:SetData(nil,val)
		end
		c:SetData(0,0)
	end

	if IsHID then
		function i.dodge:SetDodge(val)
			if val and type(val)=="number" then self.dodgevalue = val end
			if (math.abs(self.dodgevalue) > MATH_PREC) then
				self:SetString(tostring(self.dmg).." "..percentstr(self.dodgevalue))
			else
				self:SetString("")
			end
		end

		function i.stun:SetStun(val)
			if val and type(val)=="number" then self.stunvalue = val end
			if (math.abs(self.stunvalue) > MATH_PREC) then
				self:SetString(tostring(self.dmg).." "..percentstr(self.stunvalue))
			else
				self:SetString("")
			end
		end

		function i.castfail:SetFail(val)
			if val and type(val)=="number" then self.failvalue = val end
			if (math.abs(self.failvalue) > MATH_PREC) then
				self:SetString(tostring(self.dmg).." "..percentstr(self.failvalue))
			else
				self:SetString("")
			end
		end
	end

	function i.dmgmult:SetDmgMult(val)
		if val and type(val)=="number" then self.dmgmultvalue = val end
		if math.abs(self.dmgmultvalue - 1) > MATH_PREC then
			self:SetString(tostring(self.dmg).." "..percentstr(self.dmgmultvalue))
		else
			self:SetString("")
		end
	end

	function i.defdmg:SetDmg(val)
		if val and type(val)=="number" then self.dmgvalue = val end
		if (math.abs(self.dmgvalue) > MATH_PREC) then
			self:SetString(tostring(self.dmg).." "..roundstr(self.dmgvalue))
		else
			self:SetString("")
		end
	end

	function i:ResetValues()
		if IsHID then	
			for k = 0,13,1 do
				v = string.lower(FA_DMGTYPE[k])
				if i[v] then i[v]:SetData(0,0) end
			end
			i.stun:SetStun(0)
			i.castfail:SetFail(0)
			i.dodge:SetDodge(0)
		end
		i.dmgmult.dmg="damage mult"
		i.defdmg.dmg="damage"
		i.dmgmult:SetDmgMult(1)
		i.defdmg:SetDmg(0)
		i.pname:SetString("")
	end

	i:ResetValues()

	function i:PollStart(monrate)
		if not(monrate and type(monrate)=="number") then
			monrate = 1
		end
		self.monrate = monrate
		if self.owner and self.owner.DoPeriodicTask then
			self.monitor = self.owner:DoPeriodicTask(self.monrate,
				function (ii)
					if i.target and i.target.components then
						i:ResetValues()
						if i.target.prefab then
							i.pname:SetString(i.target.prefab)
						end
						i.hp:ShowHP()
						if IsHID and i.target.components.fa_spellcaster then
							local castfail = i.target.components.fa_spellcaster.castfailure
							if  castfail and type(castfail)=="number" and i.castfail and i.castfail.SetFail then
								i.castfail:SetFail(castfail)
							end
						end
						if i.target.components.combat then
							local dmgmult = i.target.components.combat.damagemultiplier
							if  dmgmult and type(dmgmult)=="number" and i.dmgmult and i.dmgmult.SetDmgMult then
								i.dmgmult:SetDmgMult(dmgmult)
							end
							local defdmg = i.target.components.combat.defaultdamage
							if  defdmg and type(defdmg)=="number" and i.defdmg and i.defdmg.SetDmg then
								i.defdmg:SetDmg(defdmg)
							end
						end
						if i.target.components.health then
							local t = i.target.components.health
							if IsHID and t.fa_stunresistance and type(t.fa_stunresistance)=="number" and i.stun and i.stun.SetStun then
								i.stun:SetStun(t.fa_stunresistance)
							end
							if IsHID and t.fa_dodgechance and type(t.fa_dodgechance)=="number" and i.dodge and i.dodge.SetDodge then
								i.dodge:SetDodge(t.fa_dodgechance)
							end
							if IsHID and t.fa_resistances and type(t.fa_resistances)=="table" then
								for k = 0,8,1 do
									if t.fa_resistances[k] then
                                                                                local ks = string.lower(FA_DMGTYPE[k])
										if i[ks] and i[ks].SetResistance then
											i[ks]:SetResistance(t.fa_resistances[k])
										end
									end
								end
							end
							if IsHID and t.fa_protection and type(t.fa_protection)=="table" then
								for k = 0,8,1 do
									if t.fa_protection[k] then
                                                                                local ks = string.lower(FA_DMGTYPE[k])
										if i[ks] and i[ks].SetProtection then
											i[ks]:SetProtection(t.fa_protection[k])
										end
									end
								end
							end
							
						end
					end
				end)
		end	

	end
	
	function i:PollStop()
		if self.monitor and self.owner then
			self.owner:KillTask(self.owner,self.monitor)
			self.monitor = nil
		end
			
	end

	i:PollStart(0.5)
end

function SMagicWindow(inst, stats, offset)
	if not IsHID or not inst or not stats then return end
	local name = stats
	stats = stats .. "magic"
	if inst[stats] and inst[stats].Kill then inst[stats]:Kill() end
	inst[stats] = inst:AddChild(Widget(stats))
	local i = inst[stats]
	local p = GetPlayer()
	i.owner = p
	i.monitor = nil
	i.target = p
	
	local w = 75
	local h = 98
	local step = 17
	local fontsize = 16
	local y = h - step
	local c = nil
	local color = nil

	if not offset or type(offset)~="number" then offset = 0 end

	i.root = i:AddChild(Widget("ROOT"))
	i.root:SetVAnchor(ANCHOR_TOP)
	i.root:SetHAnchor(ANCHOR_LEFT)
	i.root:SetPosition(w + 50 + offset, - (h + 480))

	i.bgg = i.root:AddChild(Image("images/ui.xml", "black.tex"))
   	i.bgg:ScaleToSize(w*2,h*2)
	i.bgg:SetTint(0,0,0,0.5)

	i.title = i.root:AddChild(Text(textfont, fontsize + 1))
	i.title:SetPosition(0, y, 0)
	i.title:SetString("[ " .. name .. "'s magic ]")

	y = y - step - 5

	for k = 0,7,1 do
		v = string.lower(FA_MAGIC[k])
		y = y - step
		i[v] = i.root:AddChild(Text(textfont, fontsize))
		c = i[v]
		color = FA_MCOLOR[k]
		c:SetColour(color[1], color[2], color[3], 1)
        	c:SetPosition(0, y, 0)
		c.dmg = v
		function c:SetData(val)
			if not val or type(val)~="number" then val = 0 end
			val = math.floor(val+0.5)
			if math.abs(val) > MATH_PREC then
				self:SetString(tostring(self.dmg).." : "..tostring(val))
			else
				self:SetString("")
			end
		end
		c:SetData(0)
	end
	function i:PollStart(monrate)
		if not(monrate and type(monrate)=="number") then
			monrate = 1
		end
		self.monrate = monrate
		if self.owner and self.owner.DoPeriodicTask then
			self.monitor = self.owner:DoPeriodicTask(self.monrate,
				function (ii)
					if i.target and i.target.components then

						if i.target.components.fa_spellcaster then
							local sc = i.target.components.fa_spellcaster
    							local cl = 0
							local v = 0
							for k = 0,7,1 do
								cl = sc.casterlevel
								if(sc.casterleveloverride[k]~=nil)then
									cl = sc.casterleveloverride[k]
    								end
								v = string.lower(FA_MAGIC[k])
								if v and i[v] then
									i[v]:SetData(cl)
								end
							end

						end

					end
				end)
		end	
		
	end
	
	function i:PollStop()
		if self.monitor and self.owner then
			self.owner:KillTask(self.owner,self.monitor)
			self.monitor = nil
		end
			
	end

	i:PollStart(1)

end
