function TweakNum(inst)
	inst.OldHide = inst.Hide or function() end
	inst.OldDeactivate = inst.Deactivate or function() end
	function inst:Hide() end
	function inst:Deactivate() end

	function inst:DoHide() if self.OldHide then self:OldHide() end end
	function inst:DoDeactivate() if self.OldDeactivate then self:OldDeactivate() end end

	function inst:OnLoseFocus() end
	function inst:OnGainFocus() end
end

function TweakBadge(inst)
	inst.tweakfinished = false -- there a crazy amount of updates and some of them is happens during patching while it is not finished
	inst.bginit = false

	inst.OldHide = inst.Hide or function() end
	inst.OldDeactivate = inst.Deactivate or function() end
	inst.OldScaleTo = inst.ScaleTo or function() end
	inst.noemptyupdate = false
	inst.monitor = nil

	inst.monredrawtick = 4
	inst.monredrawcurrent = 0
	inst.monredraw = false
	inst.forcedredraw = false

	function inst:CheckVar()
		if (not self.vmax) or (type(self.vmax)~="number") then self.vmax = 100 end
		if (not self.vmin) or (type(self.vmin)~="number") then self.vmin = 0 end
		if (not self.dmax) or (type(self.dmax)~="number") then self.dmax = 0.7 end
		if (not self.dmin) or (type(self.dmin)~="number") then self.dmin = 0.4 end
		if (not self.prec) or (type(self.prec)~="number") then self.prec = 1000 end
		if (not self.precision) or (type(self.precision)~="number") then self.precision = 1 / self.prec end
		if (not self.oldpercent) or (type(self.oldpercent)~="number") then 
			self.oldpercent = 0 
			self.forcedredraw = true
		end
		if (not self.percent) or (type(self.percent)~="number") then self.percent = 0 end
		if (not self.oldvmax) or (type(self.oldvmax)~="number") then self.oldvmax = 99 end
		if self.vmax <= self.vmin then self.vmax = self.vmin + 100 end
		if (not self.unitstr) or (type(self.unitstr)~="string") then self.unitstr = "" end
	end
	
	function inst:ScaleTo(from, to, time, fn)
	end

	function inst:GetValue(val)
		self:CheckVar()
		if (not val) or (type(val)~="number") then val = 0 end
		if val > self.vmax then val = self.vmax end
		if val < self.vmin then val = self.vmin end
		return val
	end

	function inst:GetReverseValue(val)	-- returns reverse value (for DrawBar using)
		self:CheckVar()
		if (not val) or (type(val)~="number") then val = 0 end
		return self.vmax - self:GetValue(val) + self.vmin
	end

	function inst:GetValueFromPercent(percent)
		self:CheckVar()
		if (not percent) or (type(percent)~="number") then percent = 0 end
		if percent > 1 then percent = 1 end
		if percent < 0 then percent = 0 end
		return percent * ( self.vmax - self.vmin)
	end

	function inst:GetBX() return self.wd.bsx * spBarSize /2 + spBadgeSize * 0.6 + self.wd.wd end
	function inst:GetBY() return -4 * self.wd.ws end
	function inst:GetFX(p) return - (1 - p) * spBarSize / 2 end
	function inst:GetFY(p) return 0 end

	function inst:GetP(val) 
		self:CheckVar()
		local p = math.floor((self:GetValue(val) - self.vmin)/(self.vmax - self.vmin)*self.prec)/self.prec
		if p > 1 then p = 1 end
		if p < 0 then p = 0 end
		return p
	end

	function inst:SetBGTint(cc)
		if not self.tweakfinished then return end
		if self.bgg then
			local c = cc
			if (not c) or (type(c)~="string") then c = "w" end
			self.bgg:SetTint(self.wc[c][1],self.wc[c][2],self.wc[c][3],1)
		end
	end

	function inst:SetFGTint(cc)
		if not self.tweakfinished then return end
		if self.fg then
			local c = cc
			if (not c) or (type(c)~="string") then c = "g" end
			self.fg:SetTint(self.wc[c][1],self.wc[c][2],self.wc[c][3],1)
		end
	end

	function inst:SetNumValue(val)
		if not self.tweakfinished then return end
		self.percent = self:GetP(val)
		self:CheckVar()
		if self.debug then 
			print ("["..tostring(self.wname).."] SetNumValue("..tostring(val)..")")
		end
		self:SetAnimValue(val)
		self.num:SetString(roundstr(self:GetValue(val))..self.unitstr..spDelimer..roundstr(self.vmax)..self.unitstr)
	end

	function inst:IsSame(percent)
--		if true then return true end
		self:CheckVar()
		if (percent == nil) or type(percent)~="number" then return (not self.forcedredraw) and self.noemptyupdate end
		local v1 = math.abs(percent - self.oldpercent)
		local v2 = math.abs(self.vmax - self.oldvmax)
		local r = self.forcedredraw or ((v1 < self.precision) and ( v2 < self.precision))
		if self.debug then
			print ("["..tostring(self.wname).."] IsSame("..tostring(percent)..") = "..tostring(r)..", forced = "
				..tostring(self.forcedredraw)..
				", v1 = "..tostring(v1)..", v2 = "..tostring(v2)..", precision = "..tostring(self.precision))
		end
		return r
	end

	function inst:IsPoisoned() -- stub function, health have his own
		return false
	end

	function inst:DrawBar(val)
		if not self.tweakfinished then return end
		
		local p = self:GetP(val)
		if self.debug then
			print("["..tostring(self.wname).."] DrawBar("..tostring(val)..") ("..tostring(p).."%)")
		end
		if self:IsSame(p) then 
			if self.debug then
				print("["..tostring(self.wname).."] DrawBar - is same")
			end
			return 
		else 
			self.oldpercent = p 
			self.oldvmax = self.vmax 
		end
		if self.fg then 
			self.fg:SetPosition(self:GetFX(p),self:GetFY(p),0)
			self.fg:SetScale(p,1,1) 
			if self.poisonable then
				if self:IsPoisoned() then self:SetFGTint("p") else self:SetFGTint() end
			end
		end
		if self.bgg then
			local c = "w"
			if p < self.dmax then c = "y"  end
			if p < self.dmin then c = "r" end
			self:SetBGTint(c)
		end
		self.forcedredraw = false
	end

	function inst:DrawValue(val)
		if not self.tweakfinished then return end
		local p = self:GetP(val)
		if self:IsSame(p) then return end
		self:DrawBar(val)
		self:SetNumValue(val)
	end

	function inst:DrawTempValue(val)
		if not self.tweakfinished then return end
		local p = self:GetP(val)
		if self:IsSame(p) then return end
		self:DrawTemp(val)
		self:SetNumValue(val)
	end

	function inst:DrawReverseValue(val)
		if not self.tweakfinished then return end
		local p = self:GetP(val)
		if self:IsSame(p) then return end
		self:DrawBar(self:GetReverseValue(val))
		self:SetNumValue(val)
	end

	function inst:DrawReverseTempValue(val)
		if not self.tweakfinished then return end
		local p = self:GetP(val)
		if self:IsSame(p) then return end
		self:DrawTemp(self:GetReverseValue(val))
		self:SetNumValue(val)
	end

	function inst:DrawTemp(val)
		if not self.tweakfinished then return end
		local c = ""
		val = math.floor(val)
		local p = self:GetP(val)
		if self.debug then
			print("["..tostring(self.wname).."] DrawBar("..tostring(val)..") ("..tostring(p).."%)")
		end
		if self:IsSame(p) then 
			if self.debug then
				print("["..tostring(self.wname).."] DrawTemp - is same")
			end
			return 
		else 
			self.oldpercent = p 
			self.oldvmax = self.vmax 
		end
		if inst.fg then 
			self.fg:SetPosition(self:GetFX(p),self:GetFY(p),0)
			self.fg:SetScale(p,1,1) 
			if p > self.dmax then  c = "r" else c = "g" end
			self:SetFGTint(c)
		end
		if inst.bgg then
			if p < self.dmin then c = "b" else c = "w" end
			self:SetBGTint(c)
		end
		self:SetNumValue(val)
		self.forcedredraw = false
	end	
	
	function inst:SetWData(data)
		if not (data and (type(data)=="table")) then
			print ("SetWData : invalid data - "..tostring(data))
			return
		end
		self.wd = deepcopy(data)
--		PrintArray(self.wd,"wd")
	end

	function inst:SetWColor(pal) 
		if not (pal and (type(pal)=="string") and spcolor and spcolor[pal] and (type(spcolor[pal])=="table")) then
			if pal then print ("SetWColor : invalid pal - "..tostring(pal)) end
			self:SetDefaultColor()
			return
		end
		self.wc = {}
		for key,v in pairs(spcolor[pal]) do
			self.wc[key] = {}
			for i = 1,3,1 do self.wc[key][i] = GetRGBColor(v,i) end
		end
		self:ReDraw()
	end

	function inst:ApplyData()
		if (not self.wd) or (type(self.wd)~="table") then assert(modstr .. "Widget is not properly initialized") end
		self:SetPosition(self.wd.wx,self.wd.wy,0)
		self:SetScale(self.wd.ws,self.wd.ws,self.wd.ws)

		self:CheckBars()

		if self.bar then
			self.bar:SetScale(self.wd.fsx,self.wd.fsy,1)
   			self.bar:SetPosition(self:GetBX()-1,0,0)
		end

 		if self.bgg then
			self.bgg:SetScale(self.wd.bsx,self.wd.bsy,1)
 			self.bgg:SetPosition(self:GetBX(),self:GetBY(),0)
 		end

		if self.fg then
			self.fg:SetScale(1,1,1)
	   		self.fg:SetPosition(0,0,0)
		end
		
		if self.num then self.num:SetPosition(self:GetBX(),self:GetBY(),0) end
	end
	
	function inst:GetWCol()
		local p = GetSPVar("wcol")
		if p  and (type(p)=="number") then
			return p
		else
			return spo.wcol
		end
	end

	function inst:GetWXOffset()
		local p = GetSPVar("xoffset")
		if p  and (type(p)=="number") then
			return p
		else
			return spo.xoffset
		end
	end

	function inst:GetWCOffset()
		local p = GetSPVar("coffset")
		if p  and (type(p)=="number") then
			return p
		else
			return spo.coffset
		end
	end

	function inst:GetWYOffset()
		local p = GetSPVar("yoffset")
		if p  and (type(p)=="number") then
			return p
		else
			return spo.yoffset
		end
	end

	function inst:GetWID()
		if (not self.wid) or (type(self.wid)~="number") then self.wid = 2 * self:GetWCol() + math.random(1,10) end
		return self.wid
	end

	function inst:GetInitX()
		local dx = (spBarSize * spo.barscale / 2 + spBadgeSize) * spo.scale 
		dx = - math.ceil(dx / spWidgetSnap) * spWidgetSnap
		local cx = math.floor((self:GetWID()-1)/self:GetWCol()) + 1
		dx = self:GetWXOffset() + dx * cx * spo.scale - (5 + (self:GetWCOffset() + spo.scale * spBadgeSize) * (cx - 1))
		return dx
	end

	function inst:GetInitY()
		local dy = math.ceil(10 * spo.scale / spWidgetSnap) * spWidgetSnap
		local cy = (self:GetWID()-1) % self:GetWCol()
		dy = self:GetWYOffset() + dy - cy * spBadgeSize * self.wd.ws
		return dy
	end
	
	function inst:SetInitXY()
		self.wd.wx = self:GetInitX()
		self.wd.wy = self:GetInitY()
	end

	function inst:InitData(wid)
		self.wid = wid
		if not self.wname then self.wname = "unknown" end
		self:SetWData(spdata["default"])
		self:SetWColor("default")
		self:SetInitXY()
		
		self:ApplyData()

		if self.num and self.num.Kill then 
			self.num:Kill() 
		end
		self.num = self:AddChild(Text(NUMBERFONT, 28))
		self.num:SetClickable(false)
		TweakNum(self.num)
		self:CheckNum()
		self.tweakfinished = true
	end

	function inst:CheckBars()
		self:EnableBar(GetSPVar("enablebar"))
		self:EnableBG(GetSPVar("enablebg"))
		self:EnableFG(GetSPVar("enablefg"))
		self:EnableNum(GetSPVar("enablenum"))
	end

	function inst:CheckNum()
		self:EnableNum(GetSPVar("enablenum"))
	end

	function inst:EnableBar(f)
		if not self.bar then 
			self.bar = self:AddChild(Image(idir.."bar.xml", "bar.tex"))
		end
		if f then
			if self.bar then -- be paranoid, maybe creating failed
				self.bar:SetScale(self.wd.fsx,self.wd.fsy,1)
	   			self.bar:SetPosition(self:GetBX()-1,0,0)
				self.bar:MoveToBack()
				self.bar:Show()
			end
		else
			if self.bar then self.bar:Hide() end
		end
	end

	function inst:EnableBG(f)
		if not self.bginit and self.bg and IsCombinedStatus() then -- combined status here?
			if self.bg.Hide then -- disabling or killing at this stage is kinda dangerous, so just hide it
				self.bg:Hide() 
			end
			self.bginit = true
		end	

		if not self.bgg then 
			self.bgg  = self:AddChild(Image(idir.."whitebar.xml", "whitebar.tex"))
		end
		if f then
 			if self.bgg then
				self.bgg:SetScale(self.wd.bsx,self.wd.bsy,1)
 				self.bgg:SetPosition(self:GetBX(),self:GetBY(),0)
				self.bgg:Show()
 			end
		else
			if self.bgg then self.bgg:Hide() end
		end
	end

	function inst:EnableFG(f)
		if not self.fg and self.bgg then 
			self.fg = self.bgg:AddChild(Image(idir.."whitebar.xml", "whitebar.tex"))
		end
		if f then
			if self.fg then
				self.fg:SetScale(1,1,1)
		   		self.fg:SetPosition(0,0,0)
				self:SetFGTint("g")
				self:ReDraw()
				self.fg:Show()
			end
		else
			if self.fg then self.fg:Hide() end
		end
	end                                          

	function inst:EnableNum(f)
		if f and self.num then 
			self.num:Show() 
			self.num:MoveToFront() 
		end
		if not f and self.num then 
			if self.num.DoHide then self.num:DoHide() else self.num:Hide() end
		end
	end


	function inst:SetAnimValue(val)
		if not self.tweakfinished then return end
		val = math.floor(val*self.prec)/self.prec
		local p = self:GetP(val)
		local pp = 1 - p
		
		if self.anim then
			if self.debug then print("["..tostring(self.wname).."] SetAnimValue:SetPercent("..tostring(pp)..")") end
			self.anim:GetAnimState():SetPercent("anim", pp)
		end
--[[		if self.OnUpdate then 
			if self.debug then print("["..tostring(self.wname).."] SetAnimValue:OnUpdate()") end
			self:OnUpdate() 
		end ]]--
	end

	function inst:SetPercent(val, max, penaltypercent)
		if not self.tweakfinished then return end
		self:CheckVar()
		local vval = val
		if val and type(val)=="number" then
			self.percent = val
		end
		self.percent = math.floor(self.percent*self.prec)/self.prec
		if self.debug then 
			print("["..tostring(self.wname).."] SetPercent self.percent = "..tostring(self.percent))
		end
		if max and (type(max) == "number") then self.vmax = max end
		val = self:GetValueFromPercent(self.percent)
		val = math.floor(val*self.prec)/self.prec
		inst.vmax = math.floor(inst.vmax*self.prec)/self.prec
		inst.vmin = math.floor(inst.vmin*self.prec)/self.prec
		if self.debug then 
			print("["..tostring(self.wname).."] SetPercent("..tostring(vval).." -> "..tostring(val)..", "..tostring(max)..", "..tostring(penaltypercent)..")") 
		end
		self:SetNumValue(val)
		self:DrawBar(val)
		if self.topperanim then
			if self.debug then print("["..tostring(self.wname).."] SetPercent.topperanim "..tostring(penaltypercent)) end
			penaltypercent = penaltypercent or 0
			self.topperanim:GetAnimState():SetPercent("anim", penaltypercent)
		end
		self.forcedredraw = false
	end

	function inst:Hide() end
	function inst:Deactivate() end

	function inst:DoHide() if self.OldHide then self:OldHide() end end
	function inst:DoDeactivate() if self.OldDeactivate then self:OldDeactivate() end end

	function inst:OnLoseFocus() end
	function inst:OnGainFocus() end

	function inst:CustomFollowMouse()
		if not self.tweakfinished then return end
		if self.followhandler then
			self.followhandler:Remove()
			self.followhandler = nil
			local p = GetSPVar(self.wname)
			if p  then
				local l = self:GetLocalPosition()
				p.wx = l.x
				p.wy = l.y
				p.custompos = true
			end
		else
        		self.followhandler = TheInput:AddMoveHandler(function(x,y) self:DeltaPosition(x,y) end)
		end
	end

	function inst:DeltaPosition(x, y) -- crappy solution btw. there must be a constants which depends on current scale, instead of runtime calculations, 
					  -- but PC is enough fast to do lots of useless jobs.
		local delta = self:GetLocalPosition() - self:GetWorldPosition()
		x = math.ceil((x + delta.x)/spWidgetSnap)*spWidgetSnap
		y = math.ceil((y + delta.y)/spWidgetSnap)*spWidgetSnap
		self:SetPosition(x,y,0)
	end

	function inst:ShowOptions()
		if not self.tweakfinished then return end
		ShowOptionsMenu()
	end

	function inst:OnMouseButton(button, down, x, y)
		if not self.tweakfinished then return end
		if down and (button == MOUSEBUTTON_MIDDLE) then self:CustomFollowMouse() end
		local p = GetSPVar("mouse")
		if p then
			if down and (button == MOUSEBUTTON_RIGHT) then self:ShowOptions() end
		end
	end

	function inst:ReDraw(v,m)
--		if true then return end
		if not self.tweakfinished then return end
		if m then self.vmax = m end
		local p = 0
		if v then p = self:GetP(v) end
--		self.oldpercent = -1000
		self.forcedredraw = true
		if v and m then self:SetPercent(p,m) else self:SetPercent() end
		self:ForceUpdate()
		self.forcedredraw = false
	end

	function inst:ForceUpdate() -- stub function for original game widgets (san, hanger, health) forced update
	end

	function inst:ShowWidget(enable)
		if enable then
			self:Enable()
			self:Show()
		else
			self:DoHide()
			self:Disable()
		end
	end

	function inst:PollMax() --prototype for getting max value
		return 100
	end

	function inst:PollMin() --prototype
		return 0
	end

	function inst:PollCurrent() --prototype
		return 42
	end

	function inst:PollStart(monrate)
		if not(monrate and type(monrate)=="number") then
			monrate = 1
		end
		self.monrate = monrate
		if self.owner and self.owner.DoPeriodicTask then
			self.monitor = self.owner:DoPeriodicTask(self.monrate,
				function (i)
					if not inst.tweakfinished then return end

					inst.vmax = inst:PollMax()
					inst.vmin = inst:PollMin()
					local current = inst:PollCurrent()
					current = math.floor(current*self.prec)/self.prec
					inst.vmax = math.floor(inst.vmax*self.prec)/self.prec
					inst.vmin = math.floor(inst.vmin*self.prec)/self.prec
					if inst.debug then
						print ("["..tostring(self.wname).."] Poll : "..tostring(current).." / "..tostring(inst.vmax))
					end
					if inst.istemp then
						inst:DrawTemp(current,inst.vmax)
					else
						if inst.reversed then
							inst:DrawReverseValue(current,inst.vmax)
						else
							inst:DrawValue(current,inst.vmax)
						end
					end
					if inst.monredraw then
						if inst.monredrawcurrent > inst.monredrawtick then
							inst.monredrawcurrent = 0
							inst:ReDraw()
						else
							inst.monredrawcurrent = inst.monredrawcurrent + 1
						end
					end
				end)
		end	

	end

	function inst:PollStop()
		if self.monitor and self.owner then
			self.owner:KillTask(self.owner,self.monitor)
			self.monitor = nil
		end
			
	end
	inst:CheckVar()
	inst.forcedredraw = true
end
