function RestoreCustomData()
	local p = GetSPData()
	local player = GetPlayer()
	if p then
		local wcol = p.wcol
		local wscale = p.scale
		local keycode = p.keycode
		player.components.spdata:SetData(spo) 
		if wcol and (type(wcol)=="number") then p.wcol = wcol end
		if wscale and (type(wscale)=="number") then p.scale = wscale end
		if keycode and (type(keycode)=="number") then p.keycode = keycode end
		local d = deepcopy(spdata["default"])
		for k,v in pairs(spWidget) do
			if p[k] then
				p[k].wy = spWidget[k]:GetInitY()
				p[k].wx = spWidget[k]:GetInitX()
			end
		end
		ApplyCustomData()
	end
end

function SaveCustomData()
	local p = GetSPData()
	if p then
		local s = array2str(p)
		if s and (type(s)=="string") and (string.len(s) > 0) then
			print (modstr.."Saving profile data..."..tostring(string.len(s)).." bytes")
			GLOBAL.Profile:SetValue("statusplus",s)
			GLOBAL.Profile:Save()
		else
			print (modstr.."Invalid data - "..tostring(s))
		end
	end
end

function LoadCustomData()
	local p = GetSPData()
	local player = GetPlayer()
	if p  then
		local s = GLOBAL.Profile:GetValue("statusplus")
		if s and (type(s)=="string") and (string.len(s) > 0) then
			print (modstr.."Loading profile data..."..tostring(string.len(s)).." bytes")
			local a = str2array(s)
			local count = 0
			for _ in pairs(a) do count = count + 1 end
			print (modstr..tostring(count).." records loaded")
			if a and (type(a)=="table") and (count > 0) then
				a.beaver.data = (player.prefab=="woodie")
				a.abigail.data = (player.prefab=="wendy")
				a.sunshine.data = (player.prefab=="wallflower")

				if (player.prefab=="musha") then
					a.yamche.data = cfgShowYamcheStatus
					a.yamcheh.data = cfgShowYamcheStatus
					a.mstamina.data = true
					a.mfatigue.data = true
					a.mmusic.data = true
				end

				a.linkmagick.data = (player.prefab=="link")
				a.sneak.data = (player.prefab=="warfarin")
				a.sanity.data = not (player.prefab=="link")
				a.drunk.data=ISH(player.prefab)
				if player.prefab~="wx78" then a.wxlevel.data = false end
				if not IsMoisture then
					a.moisture.data = false
				end
				if not IsGlommer then
					a.glommer.data = false
				end
				player.components.spdata:Merge(a) -- profile data can be outdated
				ApplyCustomData()
			end
		end
	end
end

-- from betterconsole by squeek
function SPAddComponent()
	local character = GLOBAL.SaveGameIndex:GetSlotCharacter()
	TheSim:LoadPrefabs {character}
	local oldfn = GLOBAL.Prefabs[character].fn
	GLOBAL.Prefabs[character].fn = 
		function(...)
			local inst = oldfn(...)
			if (type(character)=="string") and (character=="woodie")then spo.beaver.data = true end
			if (type(character)=="string") and (character=="wendy")then spo.abigail.data = true end
			if (type(character)=="string") and (character=="wallflower")then spo.sunshine.data = true end
			if (type(character)=="string") and (character=="musha")then 
				spo.yamche.data = cfgShowYamcheStatus
				spo.yamcheh.data = cfgShowYamcheStatus
				spo.mstamina.data = true
				spo.mfatigue.data = true
				spo.mmusic.data = true
			end
			if (type(character)=="string") and (character=="warfarin")then spo.sneak.data = true end
			if (type(character)=="string") and (character=="link")then 
				spo.linkmagick.data = true 
				spo.sanity.data = false
			end
			if ISH(character) then
				spo.drunk.data = true
			end
			inst:AddComponent("spdata")
			if inst.components.spdata then
				inst.components.spdata:SetData(spo)
				inst.components.spdata:SetApplyFunc(ApplyCustomData)
				inst.components.spdata:SetRestoreFunc(RestoreCustomData)
				inst.components.spdata:SetLoadFunc(LoadCustomData)
				inst.components.spdata:SetSaveFunc(SaveCustomData)
				inst.components.spdata:SetResetCustomFunc(ResetCustomWidgets)
			end
			return inst
		end
end

function TweakKramped(Kramped,inst)
	inst:ListenForEvent("killed", function(inst,data) Kramped:SPReport() end)
end


function SInitSPData()
	local k = "default"
	spdata[k] = {}
	spdata[k]["wx"]		= - math.ceil((spBarSize * spo.barscale / 2 + spBadgeSize ) * spo.scale / spWidgetSnap) * spWidgetSnap -- local widget start pos
	spdata[k]["wy"]		= math.ceil(10 * spo.scale / spWidgetSnap) * spWidgetSnap
	spdata[k]["wd"] 	= 0    -- addition for X between spBadgeSize and bar
	spdata[k]["ws"] 	= spo.scale

	spdata[k]["bsx"] 	= 0.9 * spo.barscale	-- bar scale for X
	spdata[k]["bsy"] 	= 0.7   -- bar scale for Y
	spdata[k]["fsx"] 	= spdata[k].bsx + 0.08 	-- frame scale for X
	spdata[k]["fsy"] 	= spdata[k].bsy + 0.35 	-- frame scale for Y
end

function SResolution(h) -- changing defaults for h as display height
	if h < 1201 then
		spo.wcol	= 5		-- widgets in one default column
		spo.scale 	= 0.7		-- widget scale
		spo.barscale 	= 0.7		-- bar length scale
		spo.xoffset	= 0		-- offset for X coord of widget (for default/reset)
		spo.yoffset	= 0		-- offset for Y coord of widget (for default/reset)
		spo.coffset	= 40		-- offset for X coord of widget between columns
	end

	if h < 1051 then
		spo.wcol	= 4
		spo.barscale 	= 0.6
		spo.xoffset	= 30
		spo.coffset	= 30
	end

	if h < 901 then
		spo.wcol	= 3
		spo.barscale 	= 0.5
		spo.xoffset	= 40
		spo.coffset	= 10
	end

	if h < 769 then
		spo.xoffset	= 40
		spo.coffset	= 10
	end

	if h < 601 then
		spo.xoffset	= 20
		spo.coffset	= 20
	end

	if IsCombinedStatus() and not cfgHideCombinedStatus then spo.xoffset = spo.xoffset - 60 end
end

function SPostInit(inst)
	if inst and inst.components and inst.components.spdata then
		print (modstr.."Loading data...") 
		if not inst.components.spdata.done then
			print (modstr.."data not loaded...") 
			inst:DoTaskInTime(0.1, function() ApplyCustomData() end)
		else
			ApplyCustomData()
		end
        else 
		print (modstr.."spdata component failed")
	end

end

function DisableYamcheStatus(inst)
	inst.UpdateValues = function () end
	inst.OnUpdate = function () end
	inst.UpdatePosition = function () end
	inst.FollowMouseConstrained = function () end
	inst.HealthDelta = function () end
	inst.HungerDelta = function () end
	inst:StopUpdating()
	inst:Hide()
end
