function TweakWXHeart(inst)
	function inst:SetNumValue(val)
		self:CheckVar()
		local p = GetPlayer()
		local sp = GetSPVar("wxlevel")
		local s = ""
		if p and sp and sp.data and p.prefab and p.prefab=="wx78" and p.level then 
				s = " lv"..tostring(p.level) 
		end
		self.num:SetString(roundstr(self:GetValue(val))..self.unitstr..spDelimer..roundstr(self.vmax)..self.unitstr..s)
	end
end

function TweakMoisturemeter(inst)
	TweakBadge(inst)

	local oldOnUpdate = inst.OnUpdate

	function inst:OnUpdate(dt)
		oldOnUpdate(self,dt)
		self:DrawBar(self:GetReverseValue(round(self.owner.components.moisture:GetMoisture())))
	end
	inst.vmax = round(inst.owner.components.moisture.moistureclamp.max)
	inst.dmin = 0.2
	inst.dmax = 0.4
	inst:Activate()
end

function TweakBoatBadge(inst)
	local n = inst.num
	if not n then return end
	function inst:OnLoseFocus() end
	function inst:OnGainFocus() end
	function n:OnLoseFocus() end
	function n:OnGainFocus() end
	n:Show()
end

function TweakSanityBadge(inst)
	TweakBadge(inst)
	inst.monredraw = true
	local c = GetCN("sanity")
	function inst:ForceUpdate()
		if c then c:DoDelta(0) end
	end
	function inst.PollMax() 
		if c then return c:GetMaxSanity() else return 100 end 
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round(c:GetPercent()*inst:PollMax()) else return 42 end
	end
	inst:PollStart(1)
end

function TweakHungerBadge(inst)
	TweakBadge(inst)
	inst.monredraw = true
	local c = GetCN("hunger")
	function inst:ForceUpdate()
		if c then c:DoDelta(0) end
	end
	function inst.PollMax() 
		if c then return c.max else return 100 end
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round(c.current) else return 42 end
	end
	inst:PollStart(1)
end

function TweakHealthBadge(inst)
	TweakBadge(inst)

--	print (modstr.."TweakHealthBadge("..tostring(inst)..")")
	inst.monredraw = true
--	inst.debug = true

--	local oldOnUpdate = inst.OnUpdate

	local p = GetCN("poisonable")
	local c = GetCN("health")
	function inst:IsPoisoned()
--		return false
		return p and p.IsPoisoned and p:IsPoisoned()
	end
	function inst.PollMax() 
		if c then return c:GetMaxHealth() else return 100 end
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round((c:GetPercent()+c:GetPenaltyPercent())*inst:PollMax()) else return 42 end
	end
--[[	function inst:OnUpdate(dt)
		oldOnUpdate(self,dt)
	end
]]--
	function inst:ForceUpdate()
		if self.debug then	
			print ("["..tostring(self.wname).."] DoUpdate")
		end
		if c then c:DoDelta(0) end
	end

	if IsDLC2 then
		inst.poisonable = true
	end
	inst:PollStart(1)
end

function TweakBeaverBadge(inst)
	inst.initstarted = true
	TweakBadge(inst)
	inst.dmin = 0
	inst.dmax = 0.8
	local c = GetCN("beaverness")
	if c then 
		inst.vmax = c.max 
	end
	function inst:DrawBeaver(val,data)
		if not inst.initfinished then return end
		inst:DrawTempValue(val)
		inst:SetAnimValue(val)
		if data then
			if not data.overtime then
				if data.newpercent > data.oldpercent then
					inst:PulseGreen()
					TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_up")
				elseif data.newpercent < data.oldpercent then
					TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/health_down")
					inst:PulseRed()
				end
			end
		end
	end
	function inst:ForceUpdate()
		if c then c:DoDelta(0) end
	end
	inst.initfinished = true
end

function TweakSunshineBadge(inst)
	local oldOnUpdate = inst.OnUpdate

	inst:Disable()
	TweakBadge(inst)

	inst.dmin = 0.2
	inst.dmax = 0.5
	inst.vmax = 100
	inst.noemptyupdate = true

	function inst:OnUpdate(dt)
--		oldOnUpdate(self,dt)
		if not (self.owner and self.owner.components and self.owner.components.sunshine) then return end
		local val = self.owner.components.sunshine.sunshine_charge
		inst:DrawValue(val)
--		inst:SetAnimValue(val)
	end

	inst:Enable()
end

function TweakMagickBadge(inst)
	local oldOnUpdate = inst.OnUpdate

	inst:Disable()
	TweakBadge(inst)

	inst.dmin = 0.2
	inst.dmax = 0.5
	inst.vmax = 100
	inst.noemptyupdate = true

	function inst:OnUpdate(dt)
--		oldOnUpdate(self,dt)
		if not (self.owner and self.owner.components and self.owner.components.magic) then return end
		local val = self.owner.components.magic.current
		inst.vmax = self.owner.components.magic.max
		inst.vmin = self.owner.components.magic.min
		inst:DrawValue(val)
--		inst:SetAnimValue(val)
	end

	local c = GetCN("magic")
	function inst.PollMax() 
		if c then return c.max else return 100 end
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round(c.current) else return 0 end
	end
	inst:PollStart(1)

	inst:Enable()
end

function TweakSneakBadge(inst)
	local oldOnUpdate = inst.OnUpdate

	inst:Disable()
	TweakBadge(inst)

	inst.dmin = 0.1
	inst.dmax = 0.3
	inst.vmax = 100
	inst.noemptyupdate = true
	function inst:OnUpdate(dt)
--		oldOnUpdate(self,dt)
		if not (self.owner and self.owner.components and self.owner.components.warfarinsneak) then return end
		local val = self.owner.components.warfarinsneak.current
		inst.vmax = self.owner.components.warfarinsneak.max
		inst.vmin = self.owner.components.warfarinsneak.min
		inst:DrawValue(val)
--		inst:SetAnimValue(val)
	end

	local c = GetCN("warfarinsneak")
	function inst.PollMax() 
		if c then return c.max else return 100 end 
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round(c.current) end
	end
	inst:PollStart(1)
	inst:Enable()
end

function TweakDrunkBadge(inst)
	local oldOnUpdate = inst.OnUpdate

	inst:Disable()
	TweakBadge(inst)

	inst.dmin = 0
	inst.dmax = 0.65
	inst.vmax = 100
	inst.vmin = 0
	inst.noemptyupdate = true
--	inst.reversed = true
	inst.istemp = true

	function inst:OnUpdate(dt)
--		oldOnUpdate(self,dt)
		if not (self.owner and self.owner.components and self.owner.components.fa_intoxication) then return end
		c = self.owner.components.fa_intoxication
		local val = c.current
		inst.vmax = c.max
--		inst:DrawReverseValue(val)
		inst:DrawTemp(val)
--		inst:SetAnimValue(val)
	end

	local c = GetCN("fa_intoxication")
	function inst.PollMax() 
		if c then return c.max else return 100 end
	end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if c then return round(c.current) end
	end
	inst:PollStart(1)

	inst:Enable()
end


function TweakMushaStaminaBadge(inst)
	TweakBadge(inst)
	inst.vmax = 100
	inst.monredraw = true

	local p = GetPlayer()
	function inst.PollMax() return 100 end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		if p and p.stamina then return round(p.stamina) else return 0 end 
	end
	function inst:OnUpdate(dt)
	end

	inst:PollStart(1)
end

function TweakMushaFatigueBadge(inst)
	TweakBadge(inst)

	inst.reversed = true
	inst.vmax = 100
--	inst.monredraw = true

	local p = GetPlayer()
	function inst.PollMax() return 100 end
	function inst.PollMin() return 0 end
	function inst.PollCurrent()
		local r = 0 
		if p and p.fatigue then r = round(p.fatigue) end 
		return r
	end
	function inst:OnUpdate(dt)
	end

	inst:PollStart(1)
end

function TweakMushaMusicBadge(inst)
	TweakBadge(inst)

	inst.reversed = true
	inst.vmax = 100
--	inst.monredraw = true

	local p = GetPlayer()
	function inst.PollMax() return 100 end
	function inst.PollMin() return 0 end
	function inst.PollCurrent() 
		local r = 0 
		if p and p.music then r = round(p.music) end 
		return r
	end
	function inst:OnUpdate(dt)
	end

	inst:PollStart(1)
end
