function PlaceIt(inst, name, order)
	if inst and inst.InitData then 
		spCurrentWidget = spCurrentWidget + 1
		inst:InitData(spCurrentWidget)
		if order and type(order)=="number" then
			table.insert(spWidgetOrder, order, inst)
			table.insert(spWidgetName, order, name)
		else
			spWidgetOrder[spCurrentWidget] = inst
			spWidgetName[spCurrentWidget] = name
		end
		spWidget[name] = inst
		inst.wname = name
	end
end	


function TweakStatusDisplays(inst)
	if cfgHideCombinedStatus then
		local disableit = {"naughtiness", "naughtybadge", "temperature", "tempbadge", "worldtemp", "worldtempbadge"}
		for k,v in pairs(disableit) do
			if inst[v] then
				if inst[v].Disable then inst[v]:Disable() end
				if inst[v].Hide then inst[v]:Hide() end
			end
		end		
	end
	function inst:SetPosition(pos, y, z) -- fix for caves
    		if type(pos) == "number" then
        		if pos >= 0 then self.inst.UITransform:SetPosition(pos,y,z or 0) end
		else
--        		if not self.inst:IsValid() then print (debugstack()) end
        		if pos.x >= 0 then self.inst.UITransform:SetPosition(pos.x,pos.y,pos.z) end
		end
	end

	local p = GetPlayer()

	TweakHealthBadge(inst.heart)
	TweakSanityBadge(inst.brain)
	TweakHungerBadge(inst.stomach)

	PlaceIt(inst.heart,"health")
	PlaceIt(inst.brain,"sanity")
	PlaceIt(inst.stomach,"hunger")

	inst.temp = inst:AddChild(TempBadge(inst.owner))
	PlaceIt(inst.temp,"temp")

	if p.prefab=="wendy" then
		inst.abigail = inst:AddChild(HPBadge(inst.owner,"abigail","abigail"))
		PlaceIt(inst.abigail,"abigail")
		inst.abigail:SetPercent(0,0)
		inst.abigail:FindTarget("abigail",true)
	else
		inst.abigail = nil
	end

	if p.prefab=="woodie" then
		inst.beaver = inst:AddChild(Badge("beaver_meter", inst.owner))
		TweakBeaverBadge(inst.beaver)
		PlaceIt(inst.beaver,"beaver")
		inst.beaver.inst:ListenForEvent("beavernessdelta", function(inst, data) 
				local p = GetPlayer()
				if (p.prefab~="woodie") then return end
				if p and p.HUD and p.HUD.controls and p.HUD.controls.status and p.HUD.controls.status.beaver and p.HUD.controls.status.beaver.initfinished then
					p.HUD.controls.status.beaver:DrawBeaver(p.components.beaverness.current,data)
				end
				if p and p.HUD and p.HUD.controls and p.HUD.controls.beaverbadge and not p.HUD.controls.beaverbadge.ishacked then
	--				p.HUD.controls.beaverbadge:Disable()
					p.HUD.controls.beaverbadge.Show = function () end
					p.HUD.controls.beaverbadge:Hide()
					p.HUD.controls.beaverbadge.ishacked = true
	--				p.HUD.controls.beaverbadge:Kill()
					p.HUD.controls.status:Show()
					RedrawWidgets()
				end
			end, inst.owner)

	else
		inst.beaver = nil
	end
	
	if p.prefab=="wx78" then 
		TweakWXHeart(inst.heart)
		if inst.heart.ReDraw then inst.heart:ReDraw() end
	end

	if p.prefab=="musha" then 
		if inst.staminab and inst.staminab.Hide then
			print(modstr .. "Hiding musha's sleep/music widget")
			inst.staminab.Show = function() end
			inst.staminab:Hide()
		end
		inst.yamche = inst:AddChild(HPBadge(inst.owner,"yamche","yamche"))
		PlaceIt(inst.yamche,"yamche")
		inst.yamche:SetPercent(0,0)
		inst.yamche:FindTarget("yamche",true)

		inst.yamcheh = inst:AddChild(SHungerBadge(inst.owner,"yamcheh","yamcheh"))
		PlaceIt(inst.yamcheh,"yamcheh")
		inst.yamcheh:SetPercent(0,0)
		inst.yamcheh:FindTarget("yamche",true)

		inst.mstamina = inst:AddChild(MushaStaminaBadge(inst.owner))
		PlaceIt(inst.mstamina,"mstamina")

		inst.mfatigue = inst:AddChild(MushaFatigueBadge(inst.owner))
		PlaceIt(inst.mfatigue,"mfatigue")

		inst.mmusic = inst:AddChild(MushaMusicBadge(inst.owner))
		PlaceIt(inst.mmusic,"mmusic")
	end

	p:DoTaskInTime(0.1, function()


		if inst.beaverbadge and IsCombinedStatus() then
			inst.beaverbadge.DoHide = inst.beaverbadge.Hide
			inst.beaverbadge.DoShow = inst.beaverbadge.Show
			inst.beaverbadge.Hide = function () end
			inst.beaverbadge.Show = function () end
--			inst.beaverbadge:Disable()
			inst.beaverbadge:DoHide()
		end
  		
		if IsMoisture and IsCombinedStatus() then
			if inst.moisturemeter and inst.moisturemeter.bg then
				inst.moisturemeter.bg.Show = function () end
				inst.moisturemeter.bg:Hide()
			end
		end

		local applychanges = false
		if p.HUD and p.HUD.controls and p.HUD.controls.status and p.HUD.controls.status.children and (type(p.HUD.controls.status.children)=="table") then
			for k,v in pairs(p.HUD.controls.status.children) do
				if v and v.name and (v.name=="SunshineMeter") then
					inst.sunshine = v
					TweakSunshineBadge(v)
					PlaceIt(inst.sunshine, "sunshine", 4)
				        applychanges = true
				end
			end
			if p.HUD.controls.status.magic then
				inst.linkmagick = p.HUD.controls.status.magic
				TweakMagickBadge(inst.linkmagick)
				PlaceIt(inst.linkmagick, "linkmagick", 2)
			        applychanges = true
				
			end

			if p.HUD.controls.sneakbadge then
				inst.sneak = p.HUD.controls.sneakbadge
				TweakSneakBadge(inst.sneak)
				PlaceIt(inst.sneak, "sneak", 4)
			        applychanges = true
				
			end

			if p.HUD.controls.status.fa_intoxication then
				inst.HDrunk=p.HUD.controls.status.fa_intoxication
				TweakDrunkBadge(inst.HDrunk)
				PlaceIt(inst.HDrunk,"drunk",4)
				applychanges = true
			end

			if applychanges then
				ApplyCustomData()
			end
		else
			print ("StatusPlus: Epic fail - p.HUD.controls.status.children not found or invalid")
		end

	end)

	if IsMoisture then 
		TweakMoisturemeter(inst.moisturemeter)
		PlaceIt(inst.moisturemeter,"moisture") 
	end

	inst.krampus = inst:AddChild(KrampusBadge(inst.owner))
	PlaceIt(inst.krampus,"krampus")
	inst.krampus:SetPercent(0,TUNING.KRAMPUS_THRESHOLD)

	inst.chester = inst:AddChild(HPBadge(inst.owner,"chester","chester"))
	PlaceIt(inst.chester,"chester")
	inst.chester:SetPercent(0,0)
	inst.chester:FindTarget("chester",true)

	if IsGlommer then
		inst.glommer = inst:AddChild(HPBadge(inst.owner,"glommer","glommer"))
		PlaceIt(inst.glommer,"glommer")
		inst.glommer:SetPercent(0,0)
		inst.glommer:FindTarget("glommer",true)
	end
	
	SResistWindow(inst,"monster")
	SResistWindow(inst,"player",160)
	SMagicWindow(inst,"player")
end
